Index: ChangeLog
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/ChangeLog,v
retrieving revision 1.58
diff -u -u -r1.58 ChangeLog
--- ChangeLog	2006/02/13 12:19:05	1.58
+++ ChangeLog	2006/04/17 13:10:37
@@ -1,3 +1,7 @@
+2006-04-17  Michael Albinus  <michael.albinus@gmx.de>
+
+	* Makefile (AUTHOR_VERSION): Bump to 2.0.53.
+
 2006-02-13  Norbert Koch  <viteno@xemacs.org>
 
 	* Makefile (VERSION): XEmacs package 1.30 released.
Index: ChangeLog.upstream
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/ChangeLog.upstream,v
retrieving revision 1.12
diff -u -u -r1.12 ChangeLog.upstream
--- ChangeLog.upstream	2006/01/22 22:10:41	1.12
+++ ChangeLog.upstream	2006/04/17 13:10:38
@@ -1,3 +1,20 @@
+2006-04-17  Michael Albinus  <michael.albinus@gmx.de>
+
+	Version 2.0.53 released.
+
+	* configure.ac: Bump version.
+
+2006-03-14  Michael Albinus  <michael.albinus@gmx.de>
+
+	* Makefile.in: Implement DESTDIR support.
+
+	* INSTALL: Mention DESTDIR support.
+
+2006-01-27  Michael Albinus  <michael.albinus@gmx.de>
+
+	* configure.ac: Bump version (to 2.0.53-pre).  Update merge
+	version to 2.0.52.
+
 2006-01-22  Michael Albinus  <michael.albinus@gmx.de>
 
 	Version 2.0.52 released.
Index: Makefile
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/Makefile,v
retrieving revision 1.58
diff -u -u -r1.58 Makefile
--- Makefile	2006/02/13 12:19:05	1.58
+++ Makefile	2006/04/17 13:10:38
@@ -18,7 +18,7 @@
 # Boston, MA 02111-1307, USA.
 
 VERSION = 1.30
-AUTHOR_VERSION = 2.0.52
+AUTHOR_VERSION = 2.0.53
 MAINTAINER = Kai Großjohann <kai.grossjohann@gmx.net>
 PACKAGE = tramp
 PKG_TYPE = regular
Index: lisp/ChangeLog
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/lisp/ChangeLog,v
retrieving revision 1.31
diff -u -u -r1.31 ChangeLog
--- lisp/ChangeLog	2006/02/12 20:29:37	1.31
+++ lisp/ChangeLog	2006/04/17 13:10:41
@@ -1,8 +1,58 @@
+2006-04-17  Michael Albinus  <michael.albinus@gmx.de>
+
+	Version 2.0.53 released.
+
+2006-04-16  Michael Albinus  <michael.albinus@gmx.de>
+
+	* tramp.el (tramp-completion-mode): ?\t has event-modifier
+	'control.  Reported by Matthias Förste
+	<slashdevslashnull@gmx.net>.
+
+2006-04-13  Michael Albinus  <michael.albinus@gmx.de>
+
+	* tramp.el (tramp-display-shell-command-buffer): New defvar.
+	(tramp-handle-shell-command): Display output buffer only when
+	`tramp-display-shell-command-buffer' is true.
+	(tramp-handle-process-file): Set `tramp-display-shell-command-buffer'.
+
+2006-03-14  Michael Albinus  <michael.albinus@gmx.de>
+
+	* Makefile.in: Implement DESTDIR support.
+
 2006-02-12  Michael Albinus  <michael.albinus@gmx.de>
 
 	* tramp.el (tramp-remote-path): Add "/usr/xpg4/bin" on top,
 	because on Solaris a POSIX compatible "id" is needed.  Reported by
 	Magnus Henoch <mange@freemail.hu>.
+	(tramp-perl-encode, tramp-perl-decode): Adapt copyright years.
+
+	* tramp-uu.el, trampver.el.in: Adapt copyright years.
+
+2006-02-08  Sam Steingold  <sds@gnu.org>
+
+	* tramp.el (tramp-maybe-open-connection): Do not wait for
+	output from a dead connection.
+
+2006-02-01  Michael Albinus  <michael.albinus@gmx.de>
+
+	* tramp.el (tramp-convert-file-attributes): Set file's gid change
+	bit only when id-format is 'integer.  Reported by Matt Hodges
+	<M.P.Hodges@rl.ac.uk>.
+
+2006-01-30  Michael Albinus  <michael.albinus@gmx.de>
+
+	* tramp-smb.el (tramp-smb-wait-for-output): Wait always for the
+	prompt.  If it returns earlier (when detecting an error message),
+	the rest of the output will merge accidently with the output of
+	the next command.  Reported by M Jared Finder <jared@hpalace.com>.
+
+2006-01-27  Michael Albinus  <michael.albinus@gmx.de>
+
+	* tramp.el: Add autoload for adding
+	`tramp-completion-file-name-handler' to `file-name-handler-alist'.
+
+	* tramp-vc.el (vc-user-login-name): Wrap defadvice with a test for
+	`process-file', in order to let it work for older Emacsen too.
 
 2006-01-22  Michael Albinus  <michael.albinus@gmx.de>
 
@@ -14,7 +64,7 @@
 
 	* tramp.el (tramp-unload-file-name-handler-alist)
 	(tramp-unload-tramp): New defuns.
-	(tramp-advice-PC-expand-many-files): New defadvice.
+	(tramp-advice-PC-expand-many-files): New defadvices.
 	(tramp-save-PC-expand-many-files, tramp-setup-complete) Defuns
 	removed.
 
Index: lisp/tramp-smb.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/lisp/tramp-smb.el,v
retrieving revision 1.7
diff -u -u -r1.7 tramp-smb.el
--- lisp/tramp-smb.el	2005/08/07 15:55:39	1.7
+++ lisp/tramp-smb.el	2006/04/17 13:10:41
@@ -1,6 +1,6 @@
 ;;; tramp-smb.el --- Tramp access functions for SMB servers -*- coding: iso-8859-1; -*-
 
-;; Copyright (C) 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
+;; Copyright (C) 2002, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
 
 ;; Author: Michael Albinus <michael.albinus@gmx.de>
 ;; Keywords: comm, processes
@@ -979,7 +979,7 @@
     ;; Algorithm: get waiting output.  See if last line contains
     ;; tramp-smb-prompt sentinel or tramp-smb-errors strings.
     ;; If not, wait a bit and again get waiting output.
-    (while (and (not found) (not err))
+    (while (not found)
 
       ;; Accept pending output.
       (tramp-accept-process-output proc)
Index: lisp/tramp-uu.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/lisp/tramp-uu.el,v
retrieving revision 1.5
diff -u -u -r1.5 tramp-uu.el
--- lisp/tramp-uu.el	2005/08/07 15:55:39	1.5
+++ lisp/tramp-uu.el	2006/04/17 13:10:41
@@ -1,7 +1,7 @@
 ;;; -*- coding: iso-2022-7bit; -*-
 ;;; tramp-uu.el --- uuencode in Lisp
 
-;; Copyright (C) 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
+;; Copyright (C) 2002, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
 
 ;; Author: Kai Gro,A_(Bjohann <kai.grossjohann@gmx.net>
 ;; Keywords: comm, terminals
Index: lisp/tramp-vc.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/lisp/tramp-vc.el,v
retrieving revision 1.16
diff -u -u -r1.16 tramp-vc.el
--- lisp/tramp-vc.el	2006/01/22 22:10:49	1.16
+++ lisp/tramp-vc.el	2006/04/17 13:10:42
@@ -436,26 +436,30 @@
 	      (t	   (error "tramp-handle-vc-user-login-name cannot cope!")))))))
 
 
-(defadvice vc-user-login-name
-  (around tramp-vc-user-login-name activate)
-  "Support for files on remote machines accessed by TRAMP."
-  ;; We rely on the fact that `file' is bound when this is called.
-  ;; This appears to be the case everywhere in vc.el and vc-hooks.el
-  ;; as of Emacs 20.5.
-  ;;
-  ;; CCC TODO there should be a real solution!  Talk to Andre Spiegel
-  ;; about this.
-  (let ((file (when (boundp 'file)
-                (symbol-value 'file))))    ;pacify byte-compiler
-    (or (and (stringp file)
-             (tramp-tramp-file-p file)	; tramp file
-             (setq ad-return-value
-		   (save-match-data
-		     (tramp-handle-vc-user-login-name uid)))) ; get the owner name
-        ad-do-it)))                     ; else call the original
+;; The following defadvice is no longer necessary after changes in VC
+;; on 2006-01-25, Andre.
 
-(add-hook 'tramp-unload-hook
-	  '(lambda () (ad-unadvise 'vc-user-login-name)))
+(unless (fboundp 'process-file)
+  (defadvice vc-user-login-name
+    (around tramp-vc-user-login-name activate)
+    "Support for files on remote machines accessed by TRAMP."
+    ;; We rely on the fact that `file' is bound when this is called.
+    ;; This appears to be the case everywhere in vc.el and vc-hooks.el
+    ;; as of Emacs 20.5.
+    ;;
+    ;; With Emacs 22, the definition of `vc-user-login-name' has been
+    ;; changed.  It doesn't need to be adviced any longer.
+    (let ((file (when (boundp 'file)
+		  (symbol-value 'file))))    ;pacify byte-compiler
+      (or (and (stringp file)
+	       (tramp-tramp-file-p file)	; tramp file
+	       (setq ad-return-value
+		     (save-match-data
+		       (tramp-handle-vc-user-login-name uid)))) ; get the owner name
+	  ad-do-it)))                     ; else call the original
+
+  (add-hook 'tramp-unload-hook
+	    '(lambda () (ad-unadvise 'vc-user-login-name))))
 
 
 ;; Determine the name of the user owning a file.
Index: lisp/tramp.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/lisp/tramp.el,v
retrieving revision 1.31
diff -u -u -r1.31 tramp.el
--- lisp/tramp.el	2006/02/12 20:29:37	1.31
+++ lisp/tramp.el	2006/04/17 13:10:47
@@ -1737,7 +1737,7 @@
 (defvar tramp-perl-encode
   "%s -e '
 # This script contributed by Juanma Barranquero <lektu@terra.es>.
-# Copyright (C) 2002 Free Software Foundation, Inc.
+# Copyright (C) 2002, 2006 Free Software Foundation, Inc.
 use strict;
 
 my %%trans = do {
@@ -1779,7 +1779,7 @@
 (defvar tramp-perl-decode
   "%s -e '
 # This script contributed by Juanma Barranquero <lektu@terra.es>.
-# Copyright (C) 2002 Free Software Foundation, Inc.
+# Copyright (C) 2002, 2006 Free Software Foundation, Inc.
 use strict;
 
 my %%trans = do {
@@ -3584,6 +3584,10 @@
   "Global variable keeping asynchronous process object.
 Used in `tramp-handle-shell-command'")
 
+(defvar tramp-display-shell-command-buffer t
+  "Whether to display output buffer of `shell-command'.
+This is necessary for handling DISPLAY of `process-file'.")
+
 (defun tramp-handle-shell-command (command &optional output-buffer error-buffer)
   "Like `shell-command' for tramp files.
 This will break if COMMAND prints a newline, followed by the value of
@@ -3692,7 +3696,8 @@
 	      (skip-chars-forward "^ ")
 	      (setq status (read (current-buffer)))))
 	  (unless (zerop (buffer-size))
-	    (display-buffer output-buffer))
+	    (when tramp-display-shell-command-buffer
+	      (display-buffer output-buffer)))
 	  status))
     ;; The following is only executed if something strange was
     ;; happening.  Emit a helpful message and do it anyway.
@@ -3707,11 +3712,10 @@
   (when (and (numberp buffer) (zerop buffer))
     (error "Implementation does not handle immediate return"))
   (when (consp buffer) (error "Implementation does not handle error files"))
-  (shell-command
-   (mapconcat 'tramp-shell-quote-argument
-              (cons program args)
-              " ")
-   buffer))
+  (let ((tramp-display-shell-command-buffer display))
+    (shell-command
+     (mapconcat 'tramp-shell-quote-argument (cons program args) " ")
+     buffer)))
 
 ;; File Editing.
 
@@ -4340,6 +4344,7 @@
 ;;;###autoload
 (add-to-list 'file-name-handler-alist
 	     (cons tramp-file-name-regexp 'tramp-file-name-handler))
+;;;###autoload
 (add-to-list 'file-name-handler-alist
 	     (cons tramp-completion-file-name-regexp
 		   'tramp-completion-file-name-handler))
@@ -4454,24 +4459,28 @@
      file)
     (member (match-string 1 file) (mapcar 'car tramp-methods)))
    ((or (equal last-input-event 'tab)
-	;; Emacs
-	(and (integerp last-input-event)
-	     (not (event-modifiers last-input-event))
-	     (or (char-equal last-input-event ?\?)
-		 (char-equal last-input-event ?\t) ; handled by 'tab already?
-		 (char-equal last-input-event ?\ )))
+  	;; Emacs
+  	(and (integerp last-input-event)
+	     (or
+	      ;; ?\t has event-modifier 'control
+	      (char-equal last-input-event ?\t)
+	      (and (not (event-modifiers last-input-event))
+		   (or (char-equal last-input-event ?\?)
+		       (char-equal last-input-event ?\ )))))
 	;; XEmacs
 	(and (featurep 'xemacs)
-	     (not (event-modifiers last-input-event))
-	     (or (char-equal
-		  (funcall (symbol-function 'event-to-character)
-			   last-input-event) ?\?)
-		 (char-equal
-		  (funcall (symbol-function 'event-to-character)
-			   last-input-event) ?\t)
-		 (char-equal
-		  (funcall (symbol-function 'event-to-character)
-			   last-input-event) ?\ ))))
+	     (or
+	      ;; ?\t has event-modifier 'control
+	      (char-equal
+	       (funcall (symbol-function 'event-to-character)
+			last-input-event) ?\t)
+	      (and (not (event-modifiers last-input-event))
+		   (or (char-equal
+			(funcall (symbol-function 'event-to-character)
+				 last-input-event) ?\?)
+		       (char-equal
+			(funcall (symbol-function 'event-to-character)
+				 last-input-event) ?\ ))))))
     t)))
 
 (defun tramp-completion-handle-file-exists-p (filename)
@@ -6484,7 +6493,8 @@
 		 p (processp p) (memq (process-status p) '(run open)))
 	(tramp-send-command
 	 multi-method method user host "echo are you awake" nil t)
-	(unless (tramp-wait-for-output 10)
+	(unless (and (memq (process-status p) '(run open))
+                     (tramp-wait-for-output 10))
 	  (delete-process p)
 	  (setq p nil))
 	(erase-buffer)))
@@ -6768,13 +6778,14 @@
   "Convert file-attributes ATTR generated by perl script or ls.
 Convert file mode bits to string and set virtual device number.
 Return ATTR."
+  ;; Convert file mode bits to string.
   (unless (stringp (nth 8 attr))
-    ;; Convert file mode bits to string.
     (setcar (nthcdr 8 attr) (tramp-file-mode-from-int (nth 8 attr))))
-  ;; Set file's gid change bit.
-  (setcar (nthcdr 9 attr)
-	  (not (= (nth 3 attr)
-		  (tramp-get-remote-gid multi-method method user host))))
+  ;; Set file's gid change bit.  Possible only when id-format is 'integer.
+  (when (numberp (nth 3 attr))
+    (setcar (nthcdr 9 attr)
+	    (not (= (nth 3 attr)
+		    (tramp-get-remote-gid multi-method method user host)))))
   ;; Set virtual device number.
   (setcar (nthcdr 11 attr)
           (tramp-get-device multi-method method user host))
Index: lisp/trampver.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/lisp/trampver.el,v
retrieving revision 1.12
diff -u -u -r1.12 trampver.el
--- lisp/trampver.el	2006/01/22 22:10:50	1.12
+++ lisp/trampver.el	2006/04/17 13:10:47
@@ -2,7 +2,7 @@
 ;;; trampver.el --- Transparent Remote Access, Multiple Protocol
 ;;; lisp/trampver.el.  Generated from trampver.el.in by configure.
 
-;; Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
+;; Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
 
 ;; Author: Kai Gro,A_(Bjohann <kai.grossjohann@gmx.net>
 ;; Keywords: comm, processes
@@ -30,7 +30,7 @@
 ;; are auto-frobbed from configure.ac, so you should edit that file and run
 ;; "autoconf && ./configure" to change them.
 
-(defconst tramp-version "2.0.52"
+(defconst tramp-version "2.0.53"
   "This version of Tramp.")
 
 (defconst tramp-bug-report-address "tramp-devel@gnu.org"
Index: texi/ChangeLog
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/texi/ChangeLog,v
retrieving revision 1.29
diff -u -u -r1.29 ChangeLog
--- texi/ChangeLog	2006/01/22 22:10:57	1.29
+++ texi/ChangeLog	2006/04/17 13:10:47
@@ -1,3 +1,13 @@
+2006-04-17  Michael Albinus  <michael.albinus@gmx.de>
+
+	Version 2.0.53 released.
+
+2006-03-14  Michael Albinus  <michael.albinus@gmx.de>
+
+	* Makefile.in: Implement DESTDIR support.
+
+	* trampinst.texi (Installation parameters): Mention DESTDIR support.
+
 2006-01-22  Michael Albinus  <michael.albinus@gmx.de>
 
 	Version 2.0.52 released.
Index: texi/trampver.texi
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/tramp/texi/trampver.texi,v
retrieving revision 1.12
diff -u -u -r1.12 trampver.texi
--- texi/trampver.texi	2006/01/22 22:10:57	1.12
+++ texi/trampver.texi	2006/04/17 13:10:47
@@ -4,7 +4,7 @@
 @c In the Tramp CVS, the version number is auto-frobbed from
 @c configure.ac, so you should edit that file and run
 @c "autoconf && ./configure" to change the version number.
-@set trampver 2.0.52
+@set trampver 2.0.53
 
 @c Other flags from configuration
 @set prefix /usr/local