Index: edit-utils.texi
===================================================================
RCS file: /pack/xemacscvs/XEmacs/packages/xemacs-packages/edit-utils/edit-utils.texi,v
retrieving revision 1.12
diff -u -r1.12 edit-utils.texi
--- edit-utils.texi	20 Oct 2003 15:40:02 -0000	1.12
+++ edit-utils.texi	29 Jan 2005 14:03:50 -0000
@@ -4,10 +4,11 @@
 @c Copyright (C) 2003 Jake Colman
 @c
 @c @setfilename edit-utils.info
+@settitle Editing Utilities for XEmacs
 @ifinfo
 @dircategory XEmacs Editor
 @direntry
-* Edit Utilities: (edit-utils).	Editing utilities for XEmacs.
+* Edit Utilities: (edit-utils).	Editing Utilities for XEmacs.
 @end direntry
 @end ifinfo
 
@@ -69,7 +70,7 @@
 * scroll-in-place::		Scrolling In Place
 * setnu::                       VI-style Line Number Mode
 * vertical-mode::		Vertical Mode - Editing of Vertical Text
-* align::                       Align Text to a Apecific Column, By Regexp
+* align::                       Align Text to a Specific Column, By Regexp
 * allout::                      Extensive Outline Mode
 * narrow-stack::                Extending the built-in narrowing functions
 
@@ -456,8 +457,8 @@
 @node search-buffers, uniquify, rsz-minibuf, Top
 @chapter Searching Many Buffers
 
-This package searchs all live buffers for REGEXP and presents matching lines
-in a separate buffer with hyperlinks to their occurences.
+This package searches all live buffers for REGEXP and presents matching lines
+in a separate buffer with hyperlinks to their occurrences.
 
 After creating countless buffers in an XEmacs session, the user can execute
 the following:
@@ -468,7 +469,7 @@
 
 to find all matches of the single word "problem" in any of them.  The result
 is presented in a buffer named "*Matches for "\<problem\>" in buffers*" with
-hyperlinks to any occurence.  User may navigate to the next (@kbd{n}) or
+hyperlinks to any occurrence.  User may navigate to the next (@kbd{n}) or
 previous (@kbd{p}) match.
 
 @node uniquify, winring, search-buffers, Top
@@ -909,7 +910,7 @@
 non-permanent.
 
 The command "Kill buffer <buffer> and delete entry" is handy when you have
-accidently opened a file but want to keep neither the buffer nor the entry.
+accidentally opened a file but want to keep neither the buffer nor the entry.
 
 You can erase the list of non-permanent entries by selecting "Erase
 non-permanent entries" from the menu.
@@ -1029,7 +1030,7 @@
 recent-files-sort-function. The default is 'sort.
 
 @item recent-files-find-file-command
-This variable contains to commandto execute when a file entry
+This variable contains the command to execute when a file entry
 is selected from the menu. Usually this will be @code{find-file},
 which is the default.
 
@@ -1583,8 +1584,8 @@
 @node lazy-shot, mic-paren, lazy-lock, Top
 @chapter Another Lazy Demand-Driven Fontification
 
-This is an experimental demand based font-lock implemenation.  It is
-exprimental in the sense that it relies on C support from the redisplay
+This is an experimental demand based font-lock implementation.  It is
+experimental in the sense that it relies on C support from the redisplay
 engine, that is experimental.  The code in this file is more or less
 finished.  The C code support experimental because the current design is
 rumoured to be ugly.  Secondly because XEmacs does actually display the
@@ -1770,7 +1771,7 @@
 of the same buffer.  Indirect highline uses an indirect buffer to get the
 "vision" of the buffer.  So, if you kill an indirect buffer, the base buffer
 is not affected; if you kill the base buffer, all indirect buffer related
-with the base buffer is automagicaly killed.  Also, any text
+with the base buffer is automagically killed.  Also, any text
 insertion/deletion in any indirect or base buffer is updated in all related
 buffers.
 
@@ -1880,7 +1881,7 @@
 
 This is good for things like running @code{newaliases(1)} on
 @file{/etc/aliases}, @code{xrdb(1)} on @file{~/.Xresources}, installing a new
-@file{~/.crontab}, as well as for sending signals to daemons whos
+@file{~/.crontab}, as well as for sending signals to daemons whose
 configuration files you've just finished editing.
 
 It is much safer and more powerful than using exec statements in "Local
@@ -2587,7 +2588,7 @@
 function, @code{id-select-syntactical-region}, for the kinds of syntax
 categories handled.
 
-Loading this package automatically installs its functionalty on double-clicks
+Loading this package automatically installs its functionality on double-clicks
 (or higher) of the left mouse key.  (See the documentation for the variable,
 @code{mouse-track-click-hook}, for how this is done.)  A single click of the
 left button will remove the region and reset point.
@@ -3293,19 +3294,19 @@
   (add-hook 'text-mode-hook 'turn-on-setnu-mode)
 @end example
 
-to automatically turn on line numbering when enterting text-mode.
+to automatically turn on line numbering when entering text-mode.
 
 @node vertical-mode, align, setnu, Top
 @chapter Vertical Mode - Editing of Vertical Text
 
-This minor mode allows you to conviently edit things that are oriented
+This minor mode allows you to conveniently edit things that are oriented
 vertically (like tables in computer programs): after each action, cursor
 moves down. Therefore, to move block of text to the right, you simply enter
 vertical mode and then hold @kbd{spacebar}, waiting for autorepeat to do the
 job for you.
 
 @node align, allout, vertical-mode, Top
-@chapter Align Text to a Apecific Column, By Regexp
+@chapter Align Text to a Specific Column, By Regexp
 
 This mode allows you to align regions in a context-sensitive fashion.  The
 classic use is to align assignments: