--- skk.el~	Mon Jul 10 22:23:04 2000
+++ skk.el	Fri Sep  1 08:53:34 2000
@@ -48,6 +48,7 @@
 
 
 ;;; Code:
+(require 'advice)
 (require 'skk-foreword)
 
 (defconst skk-version "10.60")