--- menubar-items.el~	Wed Apr 12 22:28:55 2000
+++ menubar-items.el	Wed Apr 12 22:30:22 2000
@@ -128,8 +128,8 @@
       "-----"
       ["%_Print Buffer" generic-print-buffer
        :active (or (valid-specifier-tag-p 'msprinter)
-		   (and (not (eq system-type 'windows-nt)
-			     (fboundp 'lpr-buffer))))
+		   (and (not (eq system-type 'windows-nt))
+			(fboundp 'lpr-buffer)))
        :suffix (if put-buffer-names-in-file-menu (buffer-name) "")]
       ["Prett%_y-Print Buffer" ps-print-buffer-with-faces
        :active (fboundp 'ps-print-buffer-with-faces)