>From steve@turnbull.sk.tsukuba.ac.jp  Fri May  9 09:53:14 2008
X-VM-Summary-Format: "%n %*%a %-17.17F %-3.3m %2d %4l/%-5c %I\"%s\"\n"
X-VM-Labels: nil
X-VM-VHeader: ("X-XEmacs-List:" "Resent-" "Sender:" "Message-ID:" "From:" "To:" "Apparently-To:" "Cc:" "Subject:" "Date:") nil
X-VM-Last-Modified: (18468 46267 643423)
X-VM-IMAP-Retrieved: nil
X-VM-POP-Retrieved: nil
X-VM-Bookmark: 1
X-VM-v5-Data: ([nil nil nil nil nil nil nil t nil]
	["3396" "Friday" "9" "May" "2008" "10:24:41" "+1000" "Steve Youngs" "steve@sxemacs.org" "<microsoft-free.87hcd8wchi.fsf@youngs.au.com>" "110" "Re: FFI XEmacs awaits you" "^Message-ID:" nil nil "5" "2008050909:24:41" "FFI XEmacs awaits you" (number " " mark "   E Steve Youngs      May  9  110/3396  " thread-indent "\"Re: FFI XEmacs awaits you\"\n") "<871w4ca86z.fsf@uwakimon.sk.tsukuba.ac.jp>" ("<microsoft-free.871w4dgztf.fsf@youngs.au.com>" "<871w4ca86z.fsf@uwakimon.sk.tsukuba.ac.jp>") nil nil nil nil nil]
	nil)
Return-Path: <steve@turnbull.sk.tsukuba.ac.jp>
X-Spam-Checker-Version: SpamAssassin 3.2.3-gr0 (2007-08-08) on
	uwakimon.sk.tsukuba.ac.jp
X-Spam-Level: 
X-Spam-Status: No, score=-2.6 required=5.0 tests=AWL,BAYES_00 autolearn=ham
	version=3.2.3-gr0
X-Original-To: steve@uwakimon.sk.tsukuba.ac.jp
Delivered-To: steve@uwakimon.sk.tsukuba.ac.jp
Received: from turnbull.sk.tsukuba.ac.jp (turnbull.sk.tsukuba.ac.jp [130.158.99.4])
	by uwakimon.sk.tsukuba.ac.jp (Postfix) with ESMTP id 4CAE61A25C3
	for <steve@uwakimon.sk.tsukuba.ac.jp>; Fri,  9 May 2008 09:53:14 +0900 (JST)
Received: from steve by turnbull.sk.tsukuba.ac.jp with local (Exim 4.63)
	(envelope-from <steve@turnbull.sk.tsukuba.ac.jp>)
	id 1JuGgX-0001dL-KG
	for steve@uwakimon.sk.tsukuba.ac.jp; Fri, 09 May 2008 09:42:06 +0900
Received: from localhost
	([127.0.0.1] helo=turnbull.sk.tsukuba.ac.jp ident=steve)
	by turnbull.sk.tsukuba.ac.jp with esmtp (Exim 4.63)
	(envelope-from <steve@sxemacs.org>)
	id 1JuGgU-0001ce-2a
	for steve@localhost; Fri, 09 May 2008 09:42:02 +0900
X-Original-To: turnbull@sk.tsukuba.ac.jp
Delivered-To: turnbull@sk.tsukuba.ac.jp
Received: from shako.sk.tsukuba.ac.jp [130.158.97.253]
	by turnbull.sk.tsukuba.ac.jp with POP3 (fetchmail-6.3.4)
	for <steve@localhost> (single-drop); Fri, 09 May 2008 09:42:02 +0900 (JST)
Received: from imss03.cc.tsukuba.ac.jp (imss03.cc.tsukuba.ac.jp [130.158.254.152])
	by mngs01.sk.tsukuba.ac.jp (Postfix) with ESMTP id 7388B56EF
	for <turnbull@sk.tsukuba.ac.jp>; Fri,  9 May 2008 09:27:18 +0900 (JST)
Received: from imss03.cc.tsukuba.ac.jp (imss03.cc.tsukuba.ac.jp [127.0.0.1])
	by postfix.imss70 (Postfix) with ESMTP id A7C7AF4003
	for <turnbull@sk.tsukuba.ac.jp>; Fri,  9 May 2008 09:27:19 +0900 (JST)
Received-SPF: none (imss03.cc.tsukuba.ac.jp: 203.206.170.37 is neither permitted nor denied by domain of sxemacs.org) client-ip=203.206.170.37; envelope-from=steve@sxemacs.org; helo=bastard.youngs.au.com;
Received: from bastard.youngs.au.com (203-206-170-37.perm.iinet.net.au [203.206.170.37])
	by imss03.cc.tsukuba.ac.jp (Postfix) with ESMTP id 1A645F4002
	for <turnbull@sk.tsukuba.ac.jp>; Fri,  9 May 2008 09:27:18 +0900 (JST)
Received: from bastard.youngs.au.com (localhost [127.0.0.1])
	by bastard.youngs.au.com (8.14.2/8.14.2) with ESMTP id m490OgB8004193
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NO)
	for <turnbull@sk.tsukuba.ac.jp>; Fri, 9 May 2008 10:24:50 +1000
Received: (from steve@localhost)
	by bastard.youngs.au.com (8.14.2/8.14.2/Submit) id m490OfsX004192;
	Fri, 9 May 2008 10:24:41 +1000
X-Authentication-Warning: bastard.youngs.au.com: steve set sender to steve@sxemacs.org using -f
Keywords: libgcj,gcc,ffi,configure,bastard,again
Organization: The SXEmacs Project
References: <microsoft-free.871w4dgztf.fsf@youngs.au.com>
	<871w4ca86z.fsf@uwakimon.sk.tsukuba.ac.jp>
X-Face:  #O)>9erkUv7RJ~0G~5_6lEMz\HC2&~&kV2bsu4TWHI_v~<8Hj%KBBj1[*\uKF*dxbEzwAli
 ;tSuN`c)F,}p|7{6lA~e.P+7Qo\A%q"lJ7/UtUX@yEZ!X"Tph(3O8`nhPJF>hI4_GOvb%X{+e*Mi_|
 ^yTf#aTwGG,(3e41?C9B7Pak*'A$+$/hV
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwBAMAAAClLOS0AAAAGFBMVEW2ro38/8dTSk8kFxZD
 NCDv6c/28OYNCQ4quIWMAAACb0lEQVQ4jW2UTW/bMAyGFbdJr/MhPmu0Ml8LU4CuAUXA12Rdco7b
 Wn+ABvT3R+WrKTYFyeF9zI+XomPqf0+T0lib/+iHyhz/Betm14a8Gb8BzZEOFccZ6PgI0g4MDL3q
 FezNo84efWYAMrAyD3rHHPIMoAgWd5BO3RxylrnqXrdg78WbqZNOQsyeMzlYXWvs19ML0hBQkPrO
 g735WGsioCCCmuWZaXN3vobODlky28rSAxjfK5kFBkSrHVVg6wtoDuYpSN62AT3RKkW+gvrkAurj
 akPicJwC7K8R1RMKtZEhM/vDy7zUrsZizrYZo4UYO09QCSzGGwi+B27p9UP6KpNN9QWcKvEVgetX
 U/DkYTNea/x+w15n51cpvWkopOO1q+WTRHK9NcbC7J38mq7AiM41Zv3JGZmz2PUZrCFgUIODFKZm
 giwuQJ/BkFF0iv4cljcFNGtGTaFMYTkg3baAlFoNFk0nqg7RRxm2jambnXHhkkB1ZqAWc4mYAC9y
 OZ6hspDnRTL1D3AU5SwLZtR7NXBe0XeOrJWj59JDFrbLfVMMfiK5Upc5lq6I9DKK6fqDtVpEH7WU
 jxlbW1/Au3dOSEB7yUH7svsb0I30upaxuMS5v+gFOJ04E2iF4Oe4TDfwqZag1Aklwt522TR/HGuj
 1J6tb+vxDirHjhG4BPjVeI+oFSA7cGWntnddI1qOjiNADvO8TV9gesYW9A76IVDsf36lOn5q7dA7
 xBCrdvsVkd6cTsOLjpa+gcm5QUfbYw4EYB9AxMG38+CIHcHmC+z0Fcse9eXWydADOAFR1E/JY5YP
 7aY07YxZGv3qP8ldr/8C6dPfMJimIBwAAAAASUVORK5CYII=
X-URL: <http://www.sxemacs.org/>
X-Shop: <http://store.sxemacs.org/>
X-Request-PGP: <http://www.youngs.au.com/~steve/pgp/sryoungs.asc>
X-PeanutHorst-Lame-Score: 99.86%
X-OpenPGP-Fingerprint: 1659 2093 19D5 C06E D320  3A20 1D27 DB4B A94B 3003
X-Now-Playing: Vienna --- [Ultravox]
X-Discordian-Date: Prickle-Prickle, the 56th day of Discord, 3174. 
X-Attribution: SY
X-Arch-Repo: <http://arch.sxemacs.org/2008/>
In-Reply-To: <871w4ca86z.fsf@uwakimon.sk.tsukuba.ac.jp> (Stephen J. Turnbull's
	message of "Fri, 09 May 2008 04:48:20 +0900")
User-Agent: Gnus/5.110011 (No Gnus v0.11) SXEmacs/22.1.9 (Edsel, linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="==-=-=";
	micalg=pgp-sha1; protocol="application/pgp-signature"
Message-ID: <microsoft-free.87hcd8wchi.fsf@youngs.au.com>
From: Steve Youngs <steve@sxemacs.org>
To: "Stephen J. Turnbull" <turnbull@sk.tsukuba.ac.jp>
Subject: Re: FFI XEmacs awaits you
Date: Fri, 09 May 2008 10:24:41 +1000

--==-=-=
Content-Type: multipart/mixed; boundary="=-=-="

--=-=-=

* Stephen J Turnbull <turnbull@sk.tsukuba.ac.jp> writes:

  > Hey, thanks again!

You're welcome again!

  > Anyway, we got it and are building away.  Build was clean and XEmacs
  > starts up fine but ... oh, well, ffi doesn't work on Mac.  Not
  > entirely surprising (among other things, all the extensions are wrong,
  > need to be .dylib, not .so).

Indeed.  Think I'll fix that up so you don't need to specify an
extension at all.

  > Complaint for ffi-curl is "can't define function curl_easy_init".

That's gotta be something wrong/different about your libcurl.

  > Urg ... Gentoo makes you USE=gcj to get libffi?!  Ah well, I guess I
  > can emerge gcc again and try later.

Here's that patch to gcc I mentioned...


--=-=-=
Content-Type: text/x-patch
Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable

Index: configure.ac
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D
=2D-- configure.ac	(revision 134655)
+++ configure.ac	(working copy)
@@ -168,8 +168,7 @@
 host_tools=3D"texinfo byacc flex bison binutils gas ld fixincludes gcc sid=
 sim gdb make patch prms send-pr gprof etc expect dejagnu ash bash bzip2 m4=
 autoconf automake libtool diff rcs fileutils shellutils time textutils wdi=
ff find uudecode hello tar gzip indent recode release sed utils guile perl =
gawk findutils gettext zip fastjar gnattools"
=20
 # libgcj represents the runtime libraries only used by gcj.
=2Dlibgcj=3D"target-libffi \
=2D	target-zlib \
+libgcj=3D"target-zlib \
 	target-qthreads \
 	target-libjava"
=20
@@ -186,6 +184,7 @@
 		target-libssp \
 		target-libgfortran \
 		target-boehm-gc \
+		target-libffi \
 		${libgcj} \
 		target-libobjc \
 		target-libada"

--=-=-=
Content-Transfer-Encoding: quoted-printable


(who wants to build java crap just to get ffi)

  >> It doesn't work because you guys don't have rawrgb/rawrgba image
  >> instantiator thingy dingies. :-)

  > Those shouldn't be terribly hard to port, should they?

Not overly, no.  Just more of the same kinda shit I had to do for FFI.

  > But ffi-magic.el, what a hoot ... did you know that the FSF guys
  > have at least one project going where they're trying to reproduce
  > libmagic in Lisp?  Like, why bother, eh?

I had no idea.  Better not tell em that ffi-magic.el took me a grand
total of 15 minutes to write (including debugging/testing)... OTOH, how
mean are you feeling? :-P

  > Not to mention, how sweet of you! you created it on my birthday!

Awwww, if I'd known, I'da baked a cake!  Happy b'day for that day.  How
old?=20

=2D-=20
|---<Steve Youngs>---------------<GnuPG KeyID: A94B3003>---|
|       SXEmacs - The only _______ you'll ever need.       |
|         Fill in the blank, yes, it's THAT good!          |
|------------------------------------<steve@sxemacs.org>---|

--=-=-=--

--==-=-=
Content-Type: application/pgp-signature

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v2.0.8 (GNU/Linux)
Comment: The SXEmacs Project <http://www.sxemacs.org/>
Comment: EMchat - The SXEmacs IM client <http://www.emchat.org/>

iEYEARECAAYFAkgjmckACgkQHSfbS6lLMAO1EwCeIAgIIrXyoG1mdGU9D/bHMPkS
veMAoI6W+YJ2Lnpli5OdpSUPLE92Bybe
=07Fn
-----END PGP SIGNATURE-----
--==-=-=--